=== debian/changelog ===
bowtie2 (2.2.6-2) unstable; urgency=medium

  [ Charles Plessy ]
  * d/rules: quote variables contents passed to Makefile, closes: #809076.

 -- Andreas Tille <tille@debian.org>  Mon, 28 Dec 2015 08:23:51 +0100

bowtie2 (2.2.6-1) unstable; urgency=medium

  * Imported Upstream version 2.2.6
  * d/rules: WITH_TBB=1

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Fri, 28 Aug 2015 09:31:45 +0200
