=== debian/tests/control ===
Tests: indexing-ref-genome

Tests: binary-run
