=== debian/watch ===
version=3

opts=filenamemangle=s@.*/(bowtie2-[\d.]+)-source(\.zip)$@$1@ \
http://sf.net/bowtie-bio/bowtie2-([\d.]+)-source\.zip
