## bowtie2 2.2.9

=== debian/changelog ===
bowtie2 (2.2.9-4) unstable; urgency=medium

  * Team upload.
  * Make build reproducible by adding compiler flags
    setting -fdebug-prefix-map.

 -- Sascha Steinbiss <satta@debian.org>  Thu, 25 Aug 2016 12:47:33 +0000

bowtie2 (2.2.9-3) unstable; urgency=medium

  * Team upload.
  * Fix building with GCC 6.
    Closes: #831157.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 16 Jul 2016 03:22:51 +0000

bowtie2 (2.2.9-2) unstable; urgency=medium

  * Team upload.
  * Make build reproducible.
    - Remove embedding of build hostname, time and compiler.
    - Fix help2man wrapper heredoc.
    - Sort wildcard expansions in Makefile.
    - Pin down language settings.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Sat, 21 May 2016 17:18:25 +0000

bowtie2 (2.2.9-1) unstable; urgency=medium

  * Imported Upstream version 2.2.9
  * Bump Standards-Version
  * Revert the commit with applied patch
  * Update hardening.patch
  * Cleanup d/rules, remove CPPFLAGS as they are imported anyway

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Thu, 28 Apr 2016 09:26:48 +0200

bowtie2 (2.2.8-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version repackaged as xz
  * cme fix dpkg-control

  [ Alexandre Mestiashvili ]
  * Imported Upstream version 2.2.8
  * d/rules: export DEB_BUILD_MAINT_OPTIONS = hardening=+all
  * d/copyright: Merge Files: stanzas and update years

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Sat, 12 Mar 2016 15:57:34 +0100
