=== debian/control ===
--- 
+++ 
@@ -6,15 +6,20 @@
 Section: science
 Testsuite: autopkgtest
 Priority: optional
-Build-Depends: debhelper (>= 9.0), help2man, libtbb-dev, python
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 9.0),
+               help2man,
+               libtbb-dev,
+               python
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bowtie2.git
-Vcs-Git: git://anonscm.debian.org/debian-med/bowtie2.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/bowtie2.git
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2
 
 Package: bowtie2
 Architecture: amd64 kfreebsd-amd64
-Depends: python, ${misc:Depends}, ${shlibs:Depends}
+Depends: python,
+         ${misc:Depends},
+         ${shlibs:Depends}
 Suggests: bowtie2-examples
 Description: ultrafast memory-efficient short read aligner
  is an ultrafast and memory-efficient tool for aligning sequencing reads
