=== debian/rules ===
--- 
+++ 
@@ -2,9 +2,10 @@
 
 pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
 
-CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
-EXTRA_FLAGS := $(LDFLAGS)
+export LANG=C
+export LC_ALL=C.UTF-8
 
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
 EXTRA_OPTIONS =
@@ -13,12 +14,11 @@
 endif
 export EXTRA_OPTIONS
 
-
 %:
 	dh $@ --parallel
 
 override_dh_auto_build:
-	dh_auto_build -- EXTRA_FLAGS="$(EXTRA_FLAGS)" CPPFLAGS="$(CPPFLAGS)" $(EXTRA_OPTIONS)
+	dh_auto_build -- EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS)
 
 override_dh_installman:
 	mkdir -p $(CURDIR)/debian/$(pkg)/usr/share/man/man1/
