=== debian/changelog ===
bowtie2 (2.3.0-2) unstable; urgency=medium

  * Team upload.

  [ Sascha Steinbiss ]
  * Skip tests involving simulated reads to avoid use of non-free build-dep
    libmath-random-perl again.
    Closes: #852546
  * Add libclone-perl build dependency.

  [ Alexandre Mestiashvili ]
  * Add patch suppressing -Wmisleading-indentation warnings.

  [ Steffen Moeller ]
  * Adjust EDAM annotations.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 25 Jan 2017 16:27:13 +0100

bowtie2 (2.3.0-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * New upstream version
  * Code available on Github
  * debhelper 10
  * Remove Carlos Borroto from Uploaders
  * Remove code from test suite that is requiring non-free package
    libmath-random-perl
  * New Build-Depends to run build time test: liblocal-lib-perl

  [ Sascha Steinbiss ]
  * Even more new Build-Depends: libmath-random-perl, libtest-deep-perl
  * Disable rebuilding during tests

 -- Sascha Steinbiss <satta@debian.org>  Sat, 14 Jan 2017 07:50:51 +0000
