=== debian/control ===
--- 
+++ 
@@ -1,15 +1,17 @@
 Source: bowtie2
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Alexandre Mestiashvili <alex@biotec.tu-dresden.de>,
-           Andreas Tille <tille@debian.org>,
-           Carlos Borroto <carlos.borroto@gmail.com>
+           Andreas Tille <tille@debian.org>
 Section: science
 Testsuite: autopkgtest
 Priority: optional
-Build-Depends: debhelper (>= 9.0),
+Build-Depends: debhelper (>= 10),
                help2man,
                libtbb-dev,
-               python
+               python,
+               liblocal-lib-perl,
+               libtest-deep-perl,
+               libclone-perl
 Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bowtie2.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/bowtie2.git
