=== debian/rules ===
--- 
+++ 
@@ -9,16 +9,32 @@
 
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
 EXTRA_OPTIONS =
-ifeq ($(DEB_HOST_ARCH),amd64)
-        EXTRA_OPTIONS = WITH_TBB=1
+ifneq ($(DEB_HOST_ARCH),amd64)
+        EXTRA_OPTIONS = NO_TBB=1
 endif
 export EXTRA_OPTIONS
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_build:
 	dh_auto_build -- EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS)
+
+override_dh_auto_test:
+	$(MAKE) EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS) \
+	  bowtie2-build-s-debug \
+	  bowtie2-build-l-debug \
+	  bowtie2-align-s-debug \
+	  bowtie2-align-l-debug \
+	  bowtie2-inspect-s-debug \
+	  bowtie2-inspect-l-debug
+	make -j1 test
+
+override_dh_auto_install:
+	dh_auto_install
+
+override_dh_install:
+	dh_install -X.gitignore
 
 override_dh_installman:
 	mkdir -p $(CURDIR)/debian/$(pkg)/usr/share/man/man1/
@@ -35,7 +51,3 @@
 
 override_dh_installchangelogs:
 	dh_installchangelogs NEWS
-
-get-orig-source:
-	mkdir -p ../tarballs
-	uscan --verbose --force-download --repack --compress xz --destdir ../tarballs
