=== debian/changelog ===
bowtie2 (2.3.2-2) unstable; urgency=medium

  [ Steffen Moeller ]
  * Added RRID (SCR_005476)
  * Added OMICtools ref (OMIC_00653)

  [ matuskalas ]
  * Added bio.tools ref and removed whole URLs (@smoe decision)

  [ Alexandre Mestiashvili ]
  * Bump Standards-Version to 4.0.0
  * Hardcode binary package name instead of using dpkg-parsechangelog
  * Upload to unstable

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Thu, 27 Jul 2017 15:30:16 +0200

bowtie2 (2.3.2-1) experimental; urgency=medium

  * New upstream version 2.3.2
  * Drop libreadline-dev build dependency
  * Refresh patches

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Wed, 24 May 2017 10:33:13 +0200

bowtie2 (2.3.1-1) unstable; urgency=medium

  * New upstream version 2.3.1
  * Refresh patches
  * Add zlib1g-dev and libreadline-dev build dependencies

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Tue, 07 Mar 2017 11:10:09 +0100
