=== debian/control ===
--- 
+++ 
@@ -11,8 +11,9 @@
                python,
                liblocal-lib-perl,
                libtest-deep-perl,
-               libclone-perl
-Standards-Version: 3.9.8
+               libclone-perl,
+               zlib1g-dev
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bowtie2.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/bowtie2.git
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2
