=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
+pkg := bowtie2
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
