=== debian/changelog ===
bowtie2 (2.3.4.1-1) unstable; urgency=medium

  * New upstream version 2.3.4.1
  * Refresh d/patches/reproducible.patch
  * Check DEB_BUILD_PROFILES against nocheck, strip trailing white spaces

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Wed, 07 Feb 2018 23:23:01 +0100

bowtie2 (2.3.4-1) unstable; urgency=medium

  * New upstream version 2.3.4
  * Refresh patches
  * Update d/rules, add sanitized binaries for tests
  * Update d/bowties2.docs
  * Use /usr/share/dpkg/architecture.mk to find DEB_HOST_ARCH
  * Bump Standards-Version: to 4.1.3, debhelper and compatibility level to 11

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Sat, 06 Jan 2018 15:45:55 +0100

bowtie2 (2.3.3.1-1) unstable; urgency=medium

  * Update Files-Excluded list in d/copyright
  * Bump Standards-Version to 4.1.1
  * New upstream version 2.3.3.1
  * Refresh patches
  * Don't run random-test at all as it depends on non-free Math::Random package
  * Drop single-cpu-for-test.patch, as we disabled random-test target completely
  * Remove unnecessary testsuite line from d/control

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Fri, 13 Oct 2017 15:14:20 +0200

bowtie2 (2.3.3-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * debian/upstream/metadata: Corrected syntax
  * debian/control: policy bump to 4.0.1

  [ Alexandre Mestiashvili ]
  * Update Files-Excluded section in d/copyright
  * New upstream version 2.3.3
  * Bump Standards-Version in d/control
  * Refresh patches

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Mon, 11 Sep 2017 12:50:49 +0200
