=== debian/control ===
--- 
+++ 
@@ -3,9 +3,8 @@
 Uploaders: Alexandre Mestiashvili <alex@biotec.tu-dresden.de>,
            Andreas Tille <tille@debian.org>
 Section: science
-Testsuite: autopkgtest
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11),
                help2man,
                libtbb-dev,
                python,
@@ -13,7 +12,7 @@
                libtest-deep-perl,
                libclone-perl,
                zlib1g-dev
-Standards-Version: 4.0.0
+Standards-Version: 4.1.3
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bowtie2.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/bowtie2.git
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2
