=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,8 @@
 export LANG=C
 export LC_ALL=C.UTF-8
 
-DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
+include /usr/share/dpkg/architecture.mk
+
 EXTRA_OPTIONS =
 ifneq ($(DEB_HOST_ARCH),amd64)
         EXTRA_OPTIONS = NO_TBB=1
@@ -21,14 +22,20 @@
 	dh_auto_build -- EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS)
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	$(MAKE) EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS) \
 	  bowtie2-build-s-debug \
 	  bowtie2-build-l-debug \
 	  bowtie2-align-s-debug \
 	  bowtie2-align-l-debug \
 	  bowtie2-inspect-s-debug \
-	  bowtie2-inspect-l-debug
+	  bowtie2-inspect-l-debug \
+	  bowtie2-align-s-sanitized \
+	  bowtie2-align-l-sanitized \
+	  bowtie2-build-s-sanitized \
+	  bowtie2-build-l-sanitized
 	make -j1 test
+endif
 
 override_dh_auto_install:
 	dh_auto_install
